<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_FinalCustomerContactData StructType
 * @subpackage Structs
 */
class JP_FinalCustomerContactData extends AbstractStructBase
{
    /**
     * The Email
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Email;
    /**
     * The PhoneNumbers
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_PhoneNumber
     */
    public $PhoneNumbers;
    /**
     * The AddressData
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_FinalCustomerContactAddressData
     */
    public $AddressData;
    /**
     * Constructor method for JP_FinalCustomerContactData
     * @uses JP_FinalCustomerContactData::setEmail()
     * @uses JP_FinalCustomerContactData::setPhoneNumbers()
     * @uses JP_FinalCustomerContactData::setAddressData()
     * @param string $email
     * @param \ArrayType\ArrayOfJP_PhoneNumber $phoneNumbers
     * @param \StructType\JP_FinalCustomerContactAddressData $addressData
     */
    public function __construct($email = null, \ArrayType\ArrayOfJP_PhoneNumber $phoneNumbers = null, \StructType\JP_FinalCustomerContactAddressData $addressData = null)
    {
        $this
            ->setEmail($email)
            ->setPhoneNumbers($phoneNumbers)
            ->setAddressData($addressData);
    }
    /**
     * Get Email value
     * @return string|null
     */
    public function getEmail()
    {
        return $this->Email;
    }
    /**
     * Set Email value
     * @param string $email
     * @return \StructType\JP_FinalCustomerContactData
     */
    public function setEmail($email = null)
    {
        // validation for constraint: string
        if (!is_null($email) && !is_string($email)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($email)), __LINE__);
        }
        $this->Email = $email;
        return $this;
    }
    /**
     * Get PhoneNumbers value
     * @return \ArrayType\ArrayOfJP_PhoneNumber|null
     */
    public function getPhoneNumbers()
    {
        return $this->PhoneNumbers;
    }
    /**
     * Set PhoneNumbers value
     * @param \ArrayType\ArrayOfJP_PhoneNumber $phoneNumbers
     * @return \StructType\JP_FinalCustomerContactData
     */
    public function setPhoneNumbers(\ArrayType\ArrayOfJP_PhoneNumber $phoneNumbers = null)
    {
        $this->PhoneNumbers = $phoneNumbers;
        return $this;
    }
    /**
     * Get AddressData value
     * @return \StructType\JP_FinalCustomerContactAddressData|null
     */
    public function getAddressData()
    {
        return $this->AddressData;
    }
    /**
     * Set AddressData value
     * @param \StructType\JP_FinalCustomerContactAddressData $addressData
     * @return \StructType\JP_FinalCustomerContactData
     */
    public function setAddressData(\StructType\JP_FinalCustomerContactAddressData $addressData = null)
    {
        $this->AddressData = $addressData;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\JP_FinalCustomerContactData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
